Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# RenderState Class Reference

This represents a unique collection of RenderAttrib objects that correspond to a particular renderable state. More...

Inheritance diagram for RenderState:

List of all members.

## Public Member Functions
RenderState const | addAttrib (RenderAttrib const attrib, int override)
| Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.
RenderState const | addAttrib (RenderAttrib const attrib)
| Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.
RenderState const | adjustAllPriorities (int adjustment)
| Returns a new RenderState object that represents the same as the source state, with all attributes' override values incremented (or decremented, if negative) by the indicated amount.
| cacheRef ()
| Overrides this method to update PStats appropriately.
bool | cacheUnref ()
| Overrides this method to update PStats appropriately.
int | compareSort (RenderState const other)
| Returns -1, 0, or 1 according to the relative sorting of these two RenderStates, with regards to rendering performance, so that "heavier" RenderAttribs (as defined by RenderAttribRegistry.get_slot_sort()) are more likely to be grouped together.
int | compareTo (RenderState const other)
| Provides an arbitrary ordering among all unique RenderStates, so we can store the essentially different ones in a big set and throw away the rest.
RenderState const | compose (RenderState const other)
| Returns a new RenderState object that represents the composition of this state with the other state.
bool | cullCallback (CullTraverser trav, CullTraverserData const data)
| Calls cull_callback() on each attrib.
RenderAttrib const | getAttrib (TypeHandle type)
| Looks for a RenderAttrib of the indicated type in the state, and returns it if it is found, or NULL if it is not.
RenderAttrib const | getAttrib (int slot)
| Returns the RenderAttrib with the indicated slot index, or NULL if there is no such RenderAttrib in the state.
RenderAttrib const | getAttribDef (int slot)
| Returns the RenderAttrib with the indicated slot index, or the default attrib for that slot if there is no such RenderAttrib in the state.
RenderState const | getAutoShaderState ()
| Returns the base RenderState that should have the generated_shader stored within it, for generated shader states.
int | getBinIndex ()
| Returns the bin index indicated by the CullBinAttrib, if any, associated by this state (or the default bin index if there is no CullBinAttrib).
PyObject | getCompositionCache ()
| Returns a list of 2-tuples that represents the composition cache.
int | getCompositionCacheNumEntries ()
| Returns the number of entries in the composition cache for this RenderState.
RenderState const | getCompositionCacheResult (int n)
| Returns the result RenderState of the nth element in the composition cache.
int | getCompositionCacheSize ()
| Returns the number of slots in the composition cache for this RenderState.
RenderState const | getCompositionCacheSource (int n)
| Returns the source RenderState of the nth element in the composition cache.
int | getDrawOrder ()
| Returns the draw order indicated by the CullBinAttrib, if any, associated by this state (or 0 if there is no CullBinAttrib).
int | getGeomRendering (int geom_rendering)
| Returns the union of the Geom.GeomRendering bits that will be required once this RenderState is applied to a geom which includes the indicated geom_rendering bits.
unsigned int | getHash ()
| Returns a suitable hash value for phash_map.
PyObject | getInvertCompositionCache ()
| Returns a list of 2-tuples that represents the invert_composition cache.
int | getInvertCompositionCacheNumEntries ()
| Returns the number of entries in the invert_composition cache for this RenderState.
RenderState const | getInvertCompositionCacheResult (int n)
| Returns the result RenderState of the nth element in the invert composition cache.
int | getInvertCompositionCacheSize ()
| Returns the number of slots in the composition cache for this RenderState.
RenderState const | getInvertCompositionCacheSource (int n)
| Returns the source RenderState of the nth element in the invert composition cache.
int | getOverride (int slot)
| Looks for a RenderAttrib of the indicated type in the state, and returns its override value if it is found, or 0 if it is not.
int | getOverride (TypeHandle type)
| Looks for a RenderAttrib of the indicated type in the state, and returns its override value if it is found, or 0 if it is not.
RenderState const | getUnique ()
| Returns the pointer to the unique RenderState in the cache that is equivalent to this one.
bool | hasAttrib (TypeHandle type)
| Returns true if an attrib of the indicated type is present, false otherwise.
bool | hasAttrib (int slot)
| Returns true if an attrib of the indicated type is present, false otherwise.
bool | hasCullCallback ()
| Returns true if any of the RenderAttribs in this state request a cull_callback(), false if none of them do.
RenderState const | invertCompose (RenderState const other)
| Returns a new RenderState object that represents the composition of this state's inverse with the other state.
bool | isEmpty ()
| Returns true if the state is empty, false otherwise.
| nodeRef ()
| Overrides this method to update PStats appropriately.
bool | nodeUnref ()
| Overrides this method to update PStats appropriately.
| output (ostream out)
RenderState const | removeAttrib (TypeHandle type)
| Returns a new RenderState object that represents the same as the source state, with the indicated RenderAttrib removed.
RenderState const | removeAttrib (int slot)
| Returns a new RenderState object that represents the same as the source state, with the indicated RenderAttrib removed.
RenderState const | setAttrib (RenderAttrib const attrib, int override)
| Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.
RenderState const | setAttrib (RenderAttrib const attrib)
| Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.
| write (ostream out, int indent_level)
## Static Public Member Functions
static int | clearCache ()
| Empties the cache of composed RenderStates.
static | clearMungerCache ()
| Completely empties the cache of state + gsg -> munger, for all states and all gsg's.
static int | garbageCollect ()
| Performs a garbage-collection cycle.
static TypeHandle | getClassType ()
static int | getMaxPriority ()
| Returns the maximum priority number (sometimes called override) that may be set on any node.
static int | getNumStates ()
| Returns the total number of unique RenderState objects allocated in the world.
static int | getNumUnusedStates ()
| Returns the total number of RenderState objects that have been allocated but have no references outside of the internal RenderState cache.
static PyObject | getStates ()
| Returns a list of all of the RenderState objects in the state cache.
static | listCycles (ostream out)
| Detects all of the reference-count cycles in the cache and reports them to standard output.
static | listStates (ostream out)
| Lists all of the RenderStates in the cache to the output stream, one per line.
static RenderState const | make (RenderAttrib const attrib1, RenderAttrib const attrib2, int override)
| Returns a RenderState with two attributes set.
static RenderState const | make (RenderAttrib const attrib1, RenderAttrib const attrib2, RenderAttrib const attrib3, int override)
| Returns a RenderState with three attributes set.
static RenderState const | make (RenderAttrib const attrib1, RenderAttrib const attrib2, RenderAttrib const attrib3, RenderAttrib const attrib4, int override)
| Returns a RenderState with four attributes set.
static RenderState const | make (RenderAttrib const attrib1, RenderAttrib const attrib2, RenderAttrib const attrib3, RenderAttrib const attrib4)
| Returns a RenderState with four attributes set.
static RenderState const | make (RenderAttrib const attrib)
| Returns a RenderState with one attribute set.
static RenderState const | make (RenderAttrib const attrib, int override)
| Returns a RenderState with one attribute set.
static RenderState const | make (RenderAttrib const attrib1, RenderAttrib const attrib2, RenderAttrib const attrib3)
| Returns a RenderState with three attributes set.
static RenderState const | make (RenderAttrib const attrib1, RenderAttrib const attrib2)
| Returns a RenderState with two attributes set.
static RenderState const | makeEmpty ()
| Returns a RenderState with no attributes set.
static RenderState const | makeFullDefault ()
| Returns a RenderState with all possible attributes set to their default value.
static bool | validateStates ()
| Ensures that the cache is still stored in sorted order, and that none of the cache elements have been inadvertently deleted.

## Detailed Description

This represents a unique collection of RenderAttrib objects that correspond to a particular renderable state.

You should not attempt to create or modify a RenderState object directly. Instead, call one of the make() functions to create one for you. And instead of modifying a RenderState object, create a new one.

## Member Function Documentation

RenderState const addAttrib | ( | RenderAttrib const | attrib,
|  | int | override
| ) |  |

Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.

If there is already a RenderAttrib with the same type, it is replaced (unless the override is lower).

RenderState const addAttrib | ( | RenderAttrib const | attrib | ) |

Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.

If there is already a RenderAttrib with the same type, it is replaced (unless the override is lower).

RenderState const adjustAllPriorities | ( | int | adjustment | ) |

Returns a new RenderState object that represents the same as the source state, with all attributes' override values incremented (or decremented, if negative) by the indicated amount.

If the override would drop below zero, it is set to zero.

cacheRef | ( |  | ) |

Overrides this method to update PStats appropriately.

Reimplemented from CachedTypedWritableReferenceCount.

bool cacheUnref | ( |  | ) |

Overrides this method to update PStats appropriately.

Reimplemented from CachedTypedWritableReferenceCount.

static int clearCache | ( |  | ) | `[static]`

Empties the cache of composed RenderStates.

This makes every RenderState forget what results when it is composed with other RenderStates.

This will eliminate any RenderState objects that have been allocated but have no references outside of the internal RenderState map. It will not eliminate RenderState objects that are still in use.

Nowadays, this method should not be necessary, as reference-count cycles in the composition cache should be automatically detected and broken.

The return value is the number of RenderStates freed by this operation.

static clearMungerCache | ( |  | ) | `[static]`

Completely empties the cache of state + gsg -> munger, for all states and all gsg's.

Normally there is no need to empty this cache.

int compareSort | ( | RenderState const | other | ) |

Returns -1, 0, or 1 according to the relative sorting of these two RenderStates, with regards to rendering performance, so that "heavier" RenderAttribs (as defined by RenderAttribRegistry.get_slot_sort()) are more likely to be grouped together.

This is not related to the sorting order defined by compare_to.

int compareTo | ( | RenderState const | other | ) |

Provides an arbitrary ordering among all unique RenderStates, so we can store the essentially different ones in a big set and throw away the rest.

This method is not needed outside of the RenderState class because all equivalent RenderState objects are guaranteed to share the same pointer; thus, a pointer comparison is always sufficient.

RenderState const compose | ( | RenderState const | other | ) |

Returns a new RenderState object that represents the composition of this state with the other state.

The result of this operation is cached, and will be retained as long as both this RenderState object and the other RenderState object continue to exist. Should one of them destruct, the cached entry will be removed, and its pointer will be allowed to destruct as well.

bool cullCallback | ( | CullTraverser | trav,
|  | CullTraverserData const | data
| ) |  |

Calls cull_callback() on each attrib.

If any attrib returns false, interrupts the list and returns false immediately; otherwise, completes the list and returns true.

static int garbageCollect | ( |  | ) | `[static]`

Performs a garbage-collection cycle.

This must be called periodically if garbage-collect-states is true to ensure that RenderStates get cleaned up appropriately. It does no harm to call it even if this variable is not true, but there is probably no advantage in that case.

This automatically calls RenderAttrib.garbage_collect() as well.

RenderAttrib const getAttrib | ( | TypeHandle | type | ) |

Looks for a RenderAttrib of the indicated type in the state, and returns it if it is found, or NULL if it is not.

RenderAttrib const getAttrib | ( | int | slot | ) |

Returns the RenderAttrib with the indicated slot index, or NULL if there is no such RenderAttrib in the state.

RenderAttrib const getAttribDef | ( | int | slot | ) |

Returns the RenderAttrib with the indicated slot index, or the default attrib for that slot if there is no such RenderAttrib in the state.

RenderState const getAutoShaderState | ( |  | ) |

Returns the base RenderState that should have the generated_shader stored within it, for generated shader states.

The returned object might be the same as this object, or it might be a different RenderState with certain attributes removed, or set to their default values.

The point is to avoid needless regeneration of the shader attrib by storing the generated shader on a common RenderState object, with all irrelevant attributes removed.

int getBinIndex | ( |  | ) |

Returns the bin index indicated by the CullBinAttrib, if any, associated by this state (or the default bin index if there is no CullBinAttrib).

This function is provided as an optimization for determining this at render time.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from NodeCachedReferenceCount.

PyObject getCompositionCache | ( |  | ) |

Returns a list of 2-tuples that represents the composition cache.

For each tuple in the list, the first element is the source render, and the second is the result render. If both are None, there is no entry in the cache at that slot.

In general, a->compose(source) == result.

This has no practical value other than for examining the cache for performance analysis.

int getCompositionCacheNumEntries | ( |  | ) |

Returns the number of entries in the composition cache for this RenderState.

This is the number of other RenderStates whose composition with this one has been cached. This number is not useful for any practical reason other than performance analysis.

RenderState const getCompositionCacheResult | ( | int | n | ) |

Returns the result RenderState of the nth element in the composition cache.

Returns NULL if there doesn't happen to be an entry in the nth element.

In general, a->compose(a->get_composition_cache_source(n)) == a->get_composition_cache_result(n).

This has no practical value other than for examining the cache for performance analysis.

int getCompositionCacheSize | ( |  | ) |

Returns the number of slots in the composition cache for this RenderState.

You may use this as an upper bound when walking through all of the composition cache results via get_composition_cache_source() or result().

This has no practical value other than for examining the cache for performance analysis.

RenderState const getCompositionCacheSource | ( | int | n | ) |

Returns the source RenderState of the nth element in the composition cache.

Returns NULL if there doesn't happen to be an entry in the nth element. See get_composition_cache_result().

This has no practical value other than for examining the cache for performance analysis.

int getDrawOrder | ( |  | ) |

Returns the draw order indicated by the CullBinAttrib, if any, associated by this state (or 0 if there is no CullBinAttrib).

See get_bin_index().

int getGeomRendering | ( | int | geom_rendering | ) |

Returns the union of the Geom.GeomRendering bits that will be required once this RenderState is applied to a geom which includes the indicated geom_rendering bits.

unsigned int getHash | ( |  | ) |

Returns a suitable hash value for phash_map.

PyObject getInvertCompositionCache | ( |  | ) |

Returns a list of 2-tuples that represents the invert_composition cache.

For each tuple in the list, the first element is the source render, and the second is the result render. If both are None, there is no entry in the cache at that slot.

In general, a->invert_compose(source) == result.

This has no practical value other than for examining the cache for performance analysis.

int getInvertCompositionCacheNumEntries | ( |  | ) |

Returns the number of entries in the invert_composition cache for this RenderState.

This is similar to the composition cache, but it records cache entries for the invert_compose() operation. See get_composition_cache_num_entries().

RenderState const getInvertCompositionCacheResult | ( | int | n | ) |

Returns the result RenderState of the nth element in the invert composition cache.

Returns NULL if there doesn't happen to be an entry in the nth element.

In general, a->invert_compose(a->get_invert_composition_cache_source(n)) == a->get_invert_composition_cache_result(n).

This has no practical value other than for examining the cache for performance analysis.

int getInvertCompositionCacheSize | ( |  | ) |

Returns the number of slots in the composition cache for this RenderState.

You may use this as an upper bound when walking through all of the composition cache results via get_invert_composition_cache_source() or result().

This has no practical value other than for examining the cache for performance analysis.

RenderState const getInvertCompositionCacheSource | ( | int | n | ) |

Returns the source RenderState of the nth element in the invert composition cache.

Returns NULL if there doesn't happen to be an entry in the nth element. See get_invert_composition_cache_result().

This has no practical value other than for examining the cache for performance analysis.

static int getMaxPriority | ( |  | ) | `[static]`

Returns the maximum priority number (sometimes called override) that may be set on any node.

This may or may not be enforced, but the scene graph code assumes that no priority numbers will be larger than this, and some effects may not work properly if you use a larger number.

static int getNumStates | ( |  | ) | `[static]`

Returns the total number of unique RenderState objects allocated in the world.

This will go up and down during normal operations.

static int getNumUnusedStates | ( |  | ) | `[static]`

Returns the total number of RenderState objects that have been allocated but have no references outside of the internal RenderState cache.

A nonzero return value is not necessarily indicative of leaked references; it is normal for two RenderState objects, both of which have references held outside the cache, to have to result of their composition stored within the cache. This result will be retained within the cache until one of the base RenderStates is released.

Use list_cycles() to get an idea of the number of actual "leaked" RenderState objects.

int getOverride | ( | TypeHandle | type | ) |

Looks for a RenderAttrib of the indicated type in the state, and returns its override value if it is found, or 0 if it is not.

int getOverride | ( | int | slot | ) |

Looks for a RenderAttrib of the indicated type in the state, and returns its override value if it is found, or 0 if it is not.

static PyObject getStates | ( |  | ) | `[static]`

Returns a list of all of the RenderState objects in the state cache.

The order of elements in this cache is arbitrary.

RenderState const getUnique | ( |  | ) |

Returns the pointer to the unique RenderState in the cache that is equivalent to this one.

This may be the same pointer as this object, or it may be a different pointer; but it will be an equivalent object, and it will be a shared pointer. This may be called from time to time to improve cache benefits.

bool hasAttrib | ( | int | slot | ) |

Returns true if an attrib of the indicated type is present, false otherwise.

bool hasAttrib | ( | TypeHandle | type | ) |

Returns true if an attrib of the indicated type is present, false otherwise.

bool hasCullCallback | ( |  | ) |

Returns true if any of the RenderAttribs in this state request a cull_callback(), false if none of them do.

RenderState const invertCompose | ( | RenderState const | other | ) |

Returns a new RenderState object that represents the composition of this state's inverse with the other state.

This is similar to compose(), but is particularly useful for computing the relative state of a node as viewed from some other node.

bool isEmpty | ( |  | ) |

Returns true if the state is empty, false otherwise.

static listCycles | ( | ostream | out | ) | `[static]`

Detects all of the reference-count cycles in the cache and reports them to standard output.

These cycles may be inadvertently created when state compositions cycle back to a starting point. Nowadays, these cycles should be automatically detected and broken, so this method should never list any cycles unless there is a bug in that detection logic.

The cycles listed here are not leaks in the strictest sense of the word, since they can be reclaimed by a call to clear_cache(); but they will not be reclaimed automatically.

static listStates | ( | ostream | out | ) | `[static]`

Lists all of the RenderStates in the cache to the output stream, one per line.

This can be quite a lot of output if the cache is large, so be prepared.

static RenderState const make | ( | RenderAttrib const | attrib1,
|  | RenderAttrib const | attrib2,
|  | int | override
| ) |  | `[static]`

Returns a RenderState with two attributes set.

static RenderState const make | ( | RenderAttrib const | attrib1,
|  | RenderAttrib const | attrib2
| ) |  | `[static]`

Returns a RenderState with two attributes set.

static RenderState const make | ( | RenderAttrib const | attrib1,
|  | RenderAttrib const | attrib2,
|  | RenderAttrib const | attrib3,
|  | RenderAttrib const | attrib4,
|  | int | override
| ) |  | `[static]`

Returns a RenderState with four attributes set.

static RenderState const make | ( | RenderAttrib const | attrib,
|  | int | override
| ) |  | `[static]`

Returns a RenderState with one attribute set.

static RenderState const make | ( | RenderAttrib const | attrib1,
|  | RenderAttrib const | attrib2,
|  | RenderAttrib const | attrib3,
|  | int | override
| ) |  | `[static]`

Returns a RenderState with three attributes set.

static RenderState const make | ( | RenderAttrib const | attrib | ) | `[static]`

Returns a RenderState with one attribute set.

static RenderState const make | ( | RenderAttrib const | attrib1,
|  | RenderAttrib const | attrib2,
|  | RenderAttrib const | attrib3,
|  | RenderAttrib const | attrib4
| ) |  | `[static]`

Returns a RenderState with four attributes set.

static RenderState const make | ( | RenderAttrib const | attrib1,
|  | RenderAttrib const | attrib2,
|  | RenderAttrib const | attrib3
| ) |  | `[static]`

Returns a RenderState with three attributes set.

static RenderState const makeEmpty | ( |  | ) | `[static]`

Returns a RenderState with no attributes set.

static RenderState const makeFullDefault | ( |  | ) | `[static]`

Returns a RenderState with all possible attributes set to their default value.

nodeRef | ( |  | ) |

Overrides this method to update PStats appropriately.

Reimplemented from NodeCachedReferenceCount.

bool nodeUnref | ( |  | ) |

Overrides this method to update PStats appropriately.

Reimplemented from NodeCachedReferenceCount.

output | ( | ostream | out | ) |

RenderState const removeAttrib | ( | TypeHandle | type | ) |

Returns a new RenderState object that represents the same as the source state, with the indicated RenderAttrib removed.

RenderState const removeAttrib | ( | int | slot | ) |

Returns a new RenderState object that represents the same as the source state, with the indicated RenderAttrib removed.

RenderState const setAttrib | ( | RenderAttrib const | attrib | ) |

Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.

If there is already a RenderAttrib with the same type, it is replaced unconditionally. The override is not changed.

RenderState const setAttrib | ( | RenderAttrib const | attrib,
|  | int | override
| ) |  |

Returns a new RenderState object that represents the same as the source state, with the new RenderAttrib added.

If there is already a RenderAttrib with the same type, it is replaced unconditionally. The override is also replaced unconditionally.

static bool validateStates | ( |  | ) | `[static]`

Ensures that the cache is still stored in sorted order, and that none of the cache elements have been inadvertently deleted.

Returns true if so, false if there is a problem (which implies someone has modified one of the supposedly-const RenderState objects).

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties